SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'EtchegoyenLajePulver 4/29/2013 21:23'!
blueGhost

	^ Ghost new! !

!PacManTest methodsFor: 'actors' stamp: 'EtchegoyenLajePulver 4/29/2013 21:22'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'EtchegoyenLajePulver 4/29/2013 19:37'!
down

	^0@(-1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'EtchegoyenLajePulver 4/29/2013 19:45'!
ghostHouseDoorType

	^ GhostHouseDoorType new! !

!PacManTest methodsFor: 'movements' stamp: 'EtchegoyenLajePulver 4/29/2013 19:31'!
left

	^ -1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'EtchegoyenLajePulver 4/29/2013 19:55'!
leftTransporterType

	^ LeftTransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'EtchegoyenLajePulver 4/29/2013 19:38'!
pacman

	^ Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'EtchegoyenLajePulver 4/29/2013 19:37'!
right

	^ 1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'EtchegoyenLajePulver 4/29/2013 19:42'!
spaceType

	 ^ SpaceType new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'EtchegoyenLajePulver 4/29/2013 19:37'!
up

	^ 0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'EtchegoyenLajePulver 4/29/2013 19:30'!
wallType

	^ WallType new! !

Object subclass: #Actor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'converting' stamp: 'EtchegoyenLajePulver 4/29/2013 21:39'!
nextPositionWhenMovingInto: aLevelSquareType  going: aPoint 
	^self subclassResponsibility ! !

!Actor methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 20:15'!
position
    ^ 0@0! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:21'!
nextPositionWhenMovingInto: aLevelSquareType going: aPoint 
	^aLevelSquareType nextPositionFromFruit: self going: aPoint ! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:21'!
nextPositionWhenMovingInto: aLevelSquareType going: aPoint 
	^aLevelSquareType nextPositionFromGhost: self going: aPoint ! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:21'!
nextPositionWhenMovingInto: aLevelSquareType going: aPoint 
	^aLevelSquareType nextPositionFromPacman: self going: aPoint ! !

Object subclass: #LevelSquareType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

LevelSquareType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:14'!
nextPositionFor: anActor going: aPoint 
	^anActor nextPositionWhenMovingInto: self going: aPoint 
"	(anActor isKindOf: Pacman ) ifTrue: [^ anActor  position ] ifFalse: [^ anActor position + aPoint  ]"! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:32'!
nextPositionFromFruit: aFruit going: aPoint 
	^ aFruit position + aPoint ! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:25'!
nextPositionFromGhost: aGhost going: aPoint 
	^aGhost  position  + aPoint ! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:30'!
nextPositionFromPacman: aPacman going: aPoint 
	^ aPacman position ! !

LevelSquareType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/22/2013 21:06'!
nextPositionFor: anActor  going: aPoint 
	^anActor nextPositionWhenMovingInto: self going: aPoint .
	"(anActor  isKindOf: Fruit  ) ifTrue: [^  (5@10)  ] ifFalse: [(anActor  isKindOf: Pacman ) ifTrue: [^  (3@10)  ] ifFalse: [^ anActor  position ]]"! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:33'!
nextPositionFromFruit: aFruit going: aPoint 
	^ 5@10! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:26'!
nextPositionFromGhost: aGhost going: aPoint 
	^aGhost position ! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:30'!
nextPositionFromPacman: aPacman going: aPoint 
	^ 3@10! !

!LevelSquareType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 20:22'!
nextPositionFor: anActor going: aPoint 
	^ self subclassResponsibility ! !

!LevelSquareType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:32'!
nextPositionFromFruit: aFruit going: aPoint 
	^ self subclassResponsibility ! !

!LevelSquareType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:24'!
nextPositionFromGhost: aGhost going: aPoint 
	^self subclassResponsibility ! !

!LevelSquareType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:29'!
nextPositionFromPacman: aPacman going: aPoint 
	^self subclassResponsibility.! !

LevelSquareType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 20:25'!
nextPositionFor: anActor  going: aPoint 
	^ anActor  position + aPoint ! !

!SpaceType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:33'!
nextPositionFromFruit: aFruit going: aPoint 
	^ aFruit position  + aPoint ! !

!SpaceType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:28'!
nextPositionFromGhost: aGhost going: aPoint 
	^aGhost position + aPoint ! !

!SpaceType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:31'!
nextPositionFromPacman: aPacman going: aPoint 
	^ aPacman position + aPoint ! !

LevelSquareType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 20:25'!
nextPositionFor: anActor  going: aPoint 
	^ anActor  position! !

!WallType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:33'!
nextPositionFromFruit: aFruit going: aPoint 
	^ aFruit position ! !

!WallType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:28'!
nextPositionFromGhost: aGhost going: aPoint 
	^aGhost position ! !

!WallType methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 4/29/2013 21:31'!
nextPositionFromPacman: aPacman going: aPoint 
	^ aPacman position ! !
